#! /sw/bin/gawk -f

# 	$Id: get_chunks.awk,v 1.2 2007/04/18 22:31:32 genis Exp $	

# This script cluster blast results into big chunks.
# Hsp that are closer to interlen are clustered together.

BEGIN{
  # Bases upstream and dowstream of the hsp
  interlen=ARGV[1];
  boundaries=ARGV[2];
  ARGV[1]=ARGV[2]="";
#  interlen=5000;
#  boundaries=2000;
#  interlen=20000;
#  boundaries=5000;
#  interlen=40000;
#  boundaries=5000;
  OFS="\t";
}
NF>=8{

  gsub(/^.*___/,"",$9);
  gsub(";","");

  bol=1;

  # Checking if each hsp after the first one is in the same region
  for (ct2=1;ct2<=ct1;ct2++){
    if (seq[ct2] == $1 && $4>pos1[ct2] && $5<pos2[ct2] && $7 == strand[ct2]){
      bol=0;
      pos2[ct2]=$5+interlen;
      pos2_ori[ct2]=$5;
      scr[ct2]+=$6;
     }
  }
  # if is different from all the previous hsp save it in the array
  if (bol!=0){
    ct1++;
    seq[ct1]=$1;
    pos1[ct1]=$4-interlen;
    pos1_ori[ct1]=$4;
    if (pos1[ct1]<=0)
      pos1[ct1]=1; 
    pos2[ct1]=$5+interlen;
    pos2_ori[ct1]=$5;
    scr[ct1]=$6;
    strand[ct1]=$7;
    gff[ct1]=$0;
  }
}

END{
  for (ct3=1; ct3<=ct1;ct3++){
    split (gff[ct3],part);
    if (pos1_ori[ct3]-boundaries <= 1)
      pos1[ct3]=1;
    else 
      pos1[ct3]=pos1_ori[ct3]-boundaries;

    print part[1], part[2], part[3], pos1[ct3], pos2_ori[ct3]+boundaries,scr[ct3],
      part[7], part[8], part[9]"."ct3;

  # print part[1], part[2], part[3], pos1[ct3]+3000, pos2[ct3]-3000,scr[ct3],
  #    part[7], part[8], part[9]"."ct3;      
  }
}  
